/* +3 for Px and \0 */
#define P_PTR_STRWIDTH ((sizeof(void *) * 2) + 3)

/* print ptr in Px format in str; str should be long enough - using
   P_STR_STRWIDTH for minimal length is safe enough. Returns length of string
   (not including \0) */
int P_ptr_print(char *str, void *ptr);

/* print ptr in Px format in an automatically allocated buffer then return
   the pointer to that buffer. Caller needs to free() buffer after use */
char *P_ptr_aprint(void *ptr);

/* read Px pointer from str and convert it to pointer; returns 0 on success */
int P_ptr_scan(const char *str, void **ptr);
