#ifndef P_NET_UDP4_H
#define P_NET_UDP4_H

#include "network.h"

int P_udp4_listen(P_net_socket *sock, const char *loc_hostname, int loc_port, P_net_nonblock_t non_blocking, P_net_broadcast_t broadcast);
int P_udp4_connect(P_net_socket *sock, const char *rem_hostname, int rem_port, const char *loc_hostname, int loc_port, P_net_nonblock_t non_blocking);
int P_udp4_recvfrom(P_net_socket sock, char *buff, int maxlen, unsigned int *rem_ip, char **rem_host, int *rem_port);


#endif /* P_NET_UDP4_H */
